local t = Def.ActorFrame{};

t[#t+1] = StandardDecorationFromFileOptional("StageDisplay","StageDisplay");
t[#t+1] = StandardDecorationFromFileOptional("EditName","EditName");

local comboBonus = { PlayerNumber_P1 = 0, PlayerNumber_P2 = 0 }

if(not GAMESTATE:IsCourseMode()) then
	t[#t+1] = Def.Actor{
		JudgmentMessageCommand=function(self,param)
			-- 1) Combo Bonus:
			-- Q = step multiplier (Perfect = 55, Great = 33, other = 0)
			-- C = Current combo length (0 if your life bar is empty) 
			-- Your Combo Bonus goes up by (Q*C) after each step. So a Perfect on the
			-- first step of a combo will add 55 to it, and a Perfect on the 100th step
			-- of a combo will add 5500 to it. The maximum Combo Bonus for a song, which
			-- is from an all Perfect full-combo, is 55*S.

			local pss = STATSMAN:GetCurStageStats():GetPlayerStageStats(param.Player)
			local curCombo = pss:GetCurrentCombo()

			local q = 0
			if param.TapNoteScore == 'TapNoteScore_W1' or param.TapNoteScore == 'TapNoteScore_W2' then
				q = 55
			elseif param.TapNoteScore == 'TapNoteScore_W3' then
				q = 33
			end

			comboBonus[param.Player] = comboBonus[param.Player] + (q*curCombo)
		end;
		OffCommand=function(self)
			setenv("ComboBonusP1",comboBonus[PLAYER_1])
			setenv("ComboBonusP2",comboBonus[PLAYER_2])
		end;
	};
end

return t;