local Player = ...
assert(Player, "ScreenEvaluation BonusBar requires a Player")

local barHeight = 185

local scorePointerXOffset = Player == PLAYER_1 and 33 or -33;
local playerStageStats = STATSMAN:GetCurStageStats():GetPlayerStageStats(Player)
local playerPercent =  playerStageStats:GetPercentDancePoints()

local t = Def.ActorFrame{
	Def.Quad{
		Name="PointsBar";
		InitCommand=cmd(y,121;valign,1;zoomto,12,0;diffuse,color("#FF7300");diffusetopedge,color("#FFFF00"));
		-- todo: check accuracy of blinky
		BeginCommand=cmd(diffuseshift;effectcolor1,color("1,1,1,1");effectcolor2,color("0.75,0.75,0.75,1");effectperiod,0.5);
		OnCommand=cmd(sleep,0.3;linear,0.3;zoomy,playerPercent*barHeight);
	};

	Def.ActorFrame{
		Name="BarFrame";
		LoadActor("_frame")..{
			Name="TopPart";
			InitCommand=cmd(cropbottom,0.5;);
			OnCommand=cmd(sleep,0.3;linear,0.3;y,-58);
		};
		LoadActor("_frame")..{
			Name="MiddlePart";
			InitCommand=cmd(y,28;croptop,11/24;cropbottom,11/24;);
			OnCommand=cmd(sleep,0.3;linear,0.3;zoomy,86);
		};
		LoadActor("_frame")..{
			Name="BotPart";
			InitCommand=cmd(croptop,0.5;);
			OnCommand=cmd(sleep,0.3;linear,0.3;y,114);
		};
	};

	LoadActor("_scorepointer "..ToEnumShortString(Player))..{
		InitCommand=cmd(x,scorePointerXOffset;y,128);
		OnCommand=cmd(sleep,0.3;linear,0.3;addy,-(playerPercent*barHeight));
	};
};

return t;