local curStage = GAMESTATE:GetCurrentStage()
local stageIdx = GAMESTATE:GetCurrentStageIndex()+1
local stageText, stageColor;

function SetStageText(self)
	-- xxx: doesn't handle diet mode, which uses a different counter
	if GAMESTATE:IsDemonstration() then
		stageText = "DEMO"
	elseif GAMESTATE:IsEventMode() then
		-- xxx: only does numbers, doesn't handle Final stage
		stageText = FormatNumberAndSuffix(stageIdx)
		if stageIdx < 3 then stageColor = StageToColor('Stage_'..stageText)
		else stageColor = StageToColor('Stage_Next')
		end
	else
		local maxSongs = PREFSMAN:GetPreference("SongsPerPlay")
		local song = GAMESTATE:GetCurrentSong()
		if song then
			local songStages = 1;
			if song:IsLong() then songStages = 2
			elseif song:IsMarathon() then songStages = 3
			end
			local totalStages = (stageIdx-1)+songStages

			if totalStages == maxSongs then
				curStage = 'Stage_Final'
			end
		end
		stageText = ToEnumShortString(curStage)
		stageColor = StageToColor(curStage)
	end

	self:settext(stageText)
	self:diffuse(stageColor)
end

-- xxx: final stage uses #520021 stroke
local singleStage = Def.ActorFrame{
	LoadActor("_frame single");
	LoadFont("_arial black 20px")..{
		InitCommand=cmd(uppercase,true;y,-4;strokecolor,color("#00316B"));
		BeginCommand=function(self) SetStageText(self) end;
	};
};

local doubleStage = Def.ActorFrame{
	LoadActor("_frame double")..{ InitCommand=cmd(y,-1); };
	LoadFont("_stagefont double")..{
		InitCommand=cmd(y,-4;zoom,2;strokecolor,color("#00316B"));
		BeginCommand=function(self)
			SetStageText(self)
			self:settext(string.sub(stageText,1,3))
		end;
	};
};

local bUseDoubleStage = GAMESTATE:GetCurrentStyle():GetStyleType() == 'StyleType_OnePlayerTwoSides'

return bUseDoubleStage and doubleStage or singleStage;